with GNATCOM.Dispinterface;

package MSHTML.DispHTMLDocument_Object is

   type DispHTMLDocument_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   function Get_Script
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_all
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_body
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_activeElement
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_images
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_applets
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_links
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_forms
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_anchors
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_title
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_title
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_scripts
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_designMode
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_designMode
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_selection
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_readyState
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_frames
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_embeds
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_plugins
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_alinkColor
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_alinkColor
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_bgColor
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_bgColor
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_fgColor
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_fgColor
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_linkColor
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_linkColor
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_vlinkColor
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_vlinkColor
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_referrer
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_location
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_lastModified
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_url
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_url
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_domain
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_domain
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_cookie
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_cookie
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_expando
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_expando
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_charset
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_charset
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_defaultCharset
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_defaultCharset
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_mimeType
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_fileSize
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_fileCreatedDate
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_fileModifiedDate
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_fileUpdatedDate
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_security
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_protocol
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_nameProp
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure write
     (This    : DispHTMLDocument_Type;
      psarray : GNATCOM.Types.VARIANT;
      Free    : Boolean := True);

   procedure writeln
     (This    : DispHTMLDocument_Type;
      psarray : GNATCOM.Types.VARIANT;
      Free    : Boolean := True);

   function open
     (This     : DispHTMLDocument_Type;
      url      : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      name     : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      features : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      replace  : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure close
     (This : DispHTMLDocument_Type);

   procedure clear
     (This : DispHTMLDocument_Type);

   function queryCommandSupported
     (This  : DispHTMLDocument_Type;
      cmdID : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function queryCommandEnabled
     (This  : DispHTMLDocument_Type;
      cmdID : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function queryCommandState
     (This  : DispHTMLDocument_Type;
      cmdID : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function queryCommandIndeterm
     (This  : DispHTMLDocument_Type;
      cmdID : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function queryCommandText
     (This  : DispHTMLDocument_Type;
      cmdID : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function queryCommandValue
     (This  : DispHTMLDocument_Type;
      cmdID : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function execCommand
     (This   : DispHTMLDocument_Type;
      cmdID  : GNATCOM.Types.VARIANT;
      showUI : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      value  : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function execCommandShowHelp
     (This  : DispHTMLDocument_Type;
      cmdID : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function createElement
     (This : DispHTMLDocument_Type;
      eTag : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure Put_onhelp
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onhelp
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onclick
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onclick
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondblclick
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondblclick
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onkeyup
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onkeyup
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onkeydown
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onkeydown
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onkeypress
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onkeypress
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmouseup
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmouseup
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmousedown
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmousedown
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmousemove
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmousemove
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmouseout
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmouseout
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmouseover
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmouseover
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onreadystatechange
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onreadystatechange
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onafterupdate
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onafterupdate
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onrowexit
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onrowexit
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onrowenter
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onrowenter
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondragstart
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondragstart
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onselectstart
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onselectstart
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function elementFromPoint
     (This : DispHTMLDocument_Type;
      x    : GNATCOM.Types.VARIANT;
      y    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_parentWindow
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_styleSheets
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onbeforeupdate
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onbeforeupdate
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onerrorupdate
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onerrorupdate
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function toString
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function createStyleSheet
     (This     : DispHTMLDocument_Type;
      bstrHref : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      lIndex   : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure releaseCapture
     (This : DispHTMLDocument_Type);

   procedure recalc
     (This   : DispHTMLDocument_Type;
      fForce : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free   : Boolean := True);

   function createTextNode
     (This : DispHTMLDocument_Type;
      text : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_documentElement
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_uniqueID
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function attachEvent
     (This  : DispHTMLDocument_Type;
      event : GNATCOM.Types.VARIANT;
      pdisp : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure detachEvent
     (This  : DispHTMLDocument_Type;
      event : GNATCOM.Types.VARIANT;
      pdisp : GNATCOM.Types.VARIANT;
      Free  : Boolean := True);

   procedure Put_onrowsdelete
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onrowsdelete
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onrowsinserted
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onrowsinserted
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_oncellchange
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_oncellchange
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondatasetchanged
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondatasetchanged
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondataavailable
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondataavailable
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondatasetcomplete
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondatasetcomplete
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onpropertychange
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onpropertychange
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_dir
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_dir
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_oncontextmenu
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_oncontextmenu
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onstop
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onstop
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function createDocumentFragment
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_parentDocument
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_enableDownload
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_enableDownload
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_baseUrl
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_baseUrl
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_inheritStyleSheets
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_inheritStyleSheets
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onbeforeeditfocus
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onbeforeeditfocus
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function getElementsByName
     (This : DispHTMLDocument_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function getElementById
     (This : DispHTMLDocument_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function getElementsByTagName
     (This : DispHTMLDocument_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure focus
     (This : DispHTMLDocument_Type);

   function hasFocus
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onselectionchange
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onselectionchange
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_namespaces
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function createDocumentFromUrl
     (This        : DispHTMLDocument_Type;
      bstrURL     : GNATCOM.Types.VARIANT;
      bstrOptions : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure Put_media
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_media
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function CreateEventObject
     (This            : DispHTMLDocument_Type;
      pvarEventObject : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function FireEvent
     (This            : DispHTMLDocument_Type;
      bstrEventName   : GNATCOM.Types.VARIANT;
      pvarEventObject : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function createRenderStyle
     (This : DispHTMLDocument_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure Put_oncontrolselect
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_oncontrolselect
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_URLUnencoded
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmousewheel
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmousewheel
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_doctype
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_implementation
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function createAttribute
     (This         : DispHTMLDocument_Type;
      bstrAttrName : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function createComment
     (This     : DispHTMLDocument_Type;
      bstrData : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure Put_onfocusin
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onfocusin
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onfocusout
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onfocusout
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onactivate
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onactivate
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondeactivate
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondeactivate
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onbeforeactivate
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onbeforeactivate
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onbeforedeactivate
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onbeforedeactivate
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_compatMode
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_compatible
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_documentMode
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onstorage
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onstorage
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onstoragecommit
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onstoragecommit
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function ie8_getElementById
     (This   : DispHTMLDocument_Type;
      bstrId : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure updateSettings
     (This : DispHTMLDocument_Type);

   function Get_defaultView
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function createCDATASection
     (This : DispHTMLDocument_Type;
      text : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function getSelection
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function getElementsByTagNameNS
     (This          : DispHTMLDocument_Type;
      pvarNS        : GNATCOM.Types.VARIANT;
      bstrLocalName : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function createElementNS
     (This    : DispHTMLDocument_Type;
      pvarNS  : GNATCOM.Types.VARIANT;
      bstrTag : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function createAttributeNS
     (This         : DispHTMLDocument_Type;
      pvarNS       : GNATCOM.Types.VARIANT;
      bstrAttrName : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmsthumbnailclick
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmsthumbnailclick
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_characterSet
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function ie9_createElement
     (This    : DispHTMLDocument_Type;
      bstrTag : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ie9_createAttribute
     (This         : DispHTMLDocument_Type;
      bstrAttrName : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function getElementsByClassName
     (This : DispHTMLDocument_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function createProcessingInstruction
     (This       : DispHTMLDocument_Type;
      bstrTarget : GNATCOM.Types.VARIANT;
      bstrData   : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function adoptNode
     (This        : DispHTMLDocument_Type;
      pNodeSource : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmssitemodejumplistitemremoved
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmssitemodejumplistitemremoved
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_ie9_all
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_inputEncoding
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_xmlEncoding
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_xmlStandalone
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_xmlStandalone
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_xmlVersion
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_xmlVersion
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function hasAttributes
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onabort
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onabort
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onblur
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onblur
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_oncanplay
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_oncanplay
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_oncanplaythrough
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_oncanplaythrough
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onchange
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onchange
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondrag
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondrag
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondragend
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondragend
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondragenter
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondragenter
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondragleave
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondragleave
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondragover
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondragover
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondrop
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondrop
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ondurationchange
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ondurationchange
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onemptied
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onemptied
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onended
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onended
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onerror
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onerror
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onfocus
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onfocus
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_oninput
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_oninput
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onload
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onload
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onloadeddata
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onloadeddata
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onloadedmetadata
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onloadedmetadata
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onloadstart
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onloadstart
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onpause
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onpause
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onplay
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onplay
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onplaying
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onplaying
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onprogress
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onprogress
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onratechange
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onratechange
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onreset
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onreset
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onscroll
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onscroll
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onseeked
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onseeked
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onseeking
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onseeking
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onselect
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onselect
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onstalled
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onstalled
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onsubmit
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onsubmit
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onsuspend
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onsuspend
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_ontimeupdate
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ontimeupdate
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onvolumechange
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onvolumechange
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onwaiting
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onwaiting
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure normalize
     (This : DispHTMLDocument_Type);

   function importNode
     (This        : DispHTMLDocument_Type;
      pNodeSource : GNATCOM.Types.VARIANT;
      fDeep       : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_ie9_parentWindow
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure PutRef_ie9_body
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT);

   function Get_ie9_body
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_head
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmscontentzoom
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmscontentzoom
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmspointerdown
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmspointerdown
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmspointermove
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmspointermove
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmspointerup
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmspointerup
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmspointerover
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmspointerover
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmspointerout
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmspointerout
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmspointercancel
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmspointercancel
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmspointerhover
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmspointerhover
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmsgesturestart
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmsgesturestart
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmsgesturechange
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmsgesturechange
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmsgestureend
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmsgestureend
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmsgesturehold
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmsgesturehold
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmsgesturetap
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmsgesturetap
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmsgesturedoubletap
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmsgesturedoubletap
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmsinertiastart
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmsinertiastart
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function elementsFromPoint
     (This : DispHTMLDocument_Type;
      x    : GNATCOM.Types.VARIANT;
      y    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function elementsFromRect
     (This   : DispHTMLDocument_Type;
      left   : GNATCOM.Types.VARIANT;
      top    : GNATCOM.Types.VARIANT;
      width  : GNATCOM.Types.VARIANT;
      height : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure Put_onmsmanipulationstatechanged
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onmsmanipulationstatechanged
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_msCapsLockWarningOff
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_msCapsLockWarningOff
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_nodeType
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_parentNode
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function hasChildNodes
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_childNodes
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_attributes
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function insertBefore
     (This     : DispHTMLDocument_Type;
      newChild : GNATCOM.Types.VARIANT;
      refChild : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function removeChild
     (This     : DispHTMLDocument_Type;
      oldChild : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function replaceChild
     (This     : DispHTMLDocument_Type;
      newChild : GNATCOM.Types.VARIANT;
      oldChild : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function cloneNode
     (This  : DispHTMLDocument_Type;
      fDeep : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function removeNode
     (This  : DispHTMLDocument_Type;
      fDeep : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function swapNode
     (This      : DispHTMLDocument_Type;
      otherNode : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function replaceNode
     (This        : DispHTMLDocument_Type;
      replacement : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function appendChild
     (This     : DispHTMLDocument_Type;
      newChild : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_nodeName
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_nodeValue
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_nodeValue
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_firstChild
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_lastChild
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_previousSibling
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_nextSibling
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_ownerDocument
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_prefix
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_prefix
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_localName
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function Get_namespaceURI
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_textContent
     (This : DispHTMLDocument_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_textContent
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function isEqualNode
     (This      : DispHTMLDocument_Type;
      otherNode : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function lookupNamespaceURI
     (This       : DispHTMLDocument_Type;
      pvarPrefix : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function lookupPrefix
     (This             : DispHTMLDocument_Type;
      pvarNamespaceURI : GNATCOM.Types.VARIANT;
      Free             : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function isDefaultNamespace
     (This          : DispHTMLDocument_Type;
      pvarNamespace : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ie9_appendChild
     (This     : DispHTMLDocument_Type;
      newChild : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ie9_insertBefore
     (This     : DispHTMLDocument_Type;
      newChild : GNATCOM.Types.VARIANT;
      refChild : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ie9_removeChild
     (This     : DispHTMLDocument_Type;
      oldChild : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ie9_replaceChild
     (This     : DispHTMLDocument_Type;
      newChild : GNATCOM.Types.VARIANT;
      oldChild : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function isSameNode
     (This      : DispHTMLDocument_Type;
      otherNode : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function compareDocumentPosition
     (This      : DispHTMLDocument_Type;
      otherNode : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function isSupported
     (This    : DispHTMLDocument_Type;
      feature : GNATCOM.Types.VARIANT;
      version : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function querySelector
     (This : DispHTMLDocument_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function querySelectorAll
     (This : DispHTMLDocument_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function createNodeIterator
     (This                      : DispHTMLDocument_Type;
      pRootNode                 : GNATCOM.Types.VARIANT;
      ulWhatToShow              : GNATCOM.Types.VARIANT;
      pFilter                   : GNATCOM.Types.VARIANT;
      fEntityReferenceExpansion : GNATCOM.Types.VARIANT;
      Free                      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function createTreeWalker
     (This                      : DispHTMLDocument_Type;
      pRootNode                 : GNATCOM.Types.VARIANT;
      ulWhatToShow              : GNATCOM.Types.VARIANT;
      pFilter                   : GNATCOM.Types.VARIANT;
      fEntityReferenceExpansion : GNATCOM.Types.VARIANT;
      Free                      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_constructor
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   function createEvent
     (This      : DispHTMLDocument_Type;
      eventType : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function createRange
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

   procedure addEventListener
     (This       : DispHTMLDocument_Type;
      utype      : GNATCOM.Types.VARIANT;
      listener   : GNATCOM.Types.VARIANT;
      useCapture : GNATCOM.Types.VARIANT;
      Free       : Boolean := True);

   procedure removeEventListener
     (This       : DispHTMLDocument_Type;
      utype      : GNATCOM.Types.VARIANT;
      listener   : GNATCOM.Types.VARIANT;
      useCapture : GNATCOM.Types.VARIANT;
      Free       : Boolean := True);

   function dispatchEvent
     (This : DispHTMLDocument_Type;
      evt  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_rootElement
     (This : DispHTMLDocument_Type)
     return GNATCOM.Types.VARIANT;

end MSHTML.DispHTMLDocument_Object;

